Your search did not match any results.

JavaScript/jQuery Tab Panel - Drag & Drop

This demo illustrates how you can allow end-users to reorder, add, and remove tabs within the DevExtreme JavaScript TabPanel component.

Reorder tabs

Wrap the JavaScript TabPanel into the Sortable component and set the following properties as needed:

  • filter
    Specify a CSS selector to indicate draggable items. This demo sets filter to .dx-tab.

  • itemOrientation
    Set this property to "horizontal". When a user drags a tab, remaining items move left and right to designate the drop target.

  • onReorder
    Implement this handler to synchronize the dataSource with reordered tabs.

  • moveItemOnDrop Set this property to true to update markup after a tab is dropped.

Add or remove tabs

This demo adds and removes tabs in the following two functions:

  • addButtonHandler - a click handler for the "Add Tab" button.
  • closeButtonHandler - a click handler for a tab's Close icon. The demo uses the itemTitleTemplate property to display this icon.

Both handlers modify the JavaScript TabPanel's dataSource.

Backend API
$(() => { const tabPanel = $('#tabPanel').dxTabPanel({ dataSource: employees.slice(0, 3), itemTitleTemplate: titleTemplate, itemTemplate, height: 410, deferRendering: false, showNavButtons: true, repaintChangesOnly: true, }).dxTabPanel('instance'); $('#tabPanel').dxSortable({ moveItemOnDrop: true, filter: '.dx-tab', itemOrientation: 'horizontal', dragDirection: 'horizontal', onReorder(e) { const tabPanelItems = tabPanel.option('dataSource'); const itemData = tabPanelItems.splice(e.fromIndex, 1)[0]; tabPanelItems.splice(e.toIndex, 0, itemData); tabPanel.option('dataSource', tabPanelItems); tabPanel.option('selectedIndex', e.toIndex); }, }); const addTabButton = $('#addButton').dxButton({ icon: 'add', text: 'Add Tab', type: 'default', onClick: addButtonHandler, }).dxButton('instance'); function titleTemplate(itemData, itemIndex, itemElement) { itemElement .append($('<span>').text(`${itemData.FirstName} ${itemData.LastName}`)); if (!itemData.isLast) { itemElement .append( $('<i>') .addClass('dx-icon') .addClass('dx-icon-close') .click(() => { closeButtonHandler(itemData); }), ); } } function itemTemplate(itemData, itemIndex, itemElement) { $('<div>') .addClass('employeeInfo') .append($(`<img alt="${itemData.FirstName} ${itemData.LastName}" class="employeePhoto" src="${itemData.Picture}"/>`)) .append($('<p>').addClass('employeeNotes').append($(`<b>Position: ${itemData.Position}</b><br/>`)).append(itemData.Notes)) .appendTo(itemElement); $('<div>') .addClass('caption') .text(`${itemData.FirstName} ${itemData.LastName}'s Tasks:`) .appendTo(itemElement); const employeeTasks = tasks.filter((task) => task.EmployeeID === itemData.ID); $('<div>') .addClass('task-list') .appendTo(itemElement) .dxList({ dataSource: employeeTasks, selectionMode: 'multiple', showSelectionControls: true, disabled: true, selectedItems: employeeTasks.filter((task) => task.Status === 'Completed'), itemTemplate(data) { return $(`<div>${data.Subject}</div>`); }, }); } function addButtonHandler() { const tabPanelItems = tabPanel.option('dataSource'); const newItem = employees.filter((employee) => tabPanelItems.indexOf(employee) === -1)[0]; tabPanelItems.push(newItem); updateButtonsState(tabPanelItems); tabPanel.option('dataSource', tabPanelItems); tabPanel.option('selectedIndex', tabPanelItems.length - 1); } function closeButtonHandler(itemData) { const index = tabPanel.option('dataSource').indexOf(itemData); const tabPanelItems = tabPanel.option('dataSource'); tabPanelItems.splice(index, 1); updateButtonsState(tabPanelItems); tabPanel.option('dataSource', tabPanelItems); if (index >= tabPanelItems.length && index > 0) tabPanel.option('selectedIndex', index - 1); } function updateButtonsState(items) { addTabButton.option('disabled', items.length === employees.length); items[0].isLast = items.length === 1; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" /> <script src="js/dx.all.js?v=25.1.7"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="container"> <div id="addButton"></div> </div> <div id="tabPanel"></div> </div> </body> </html>
#container { display: flex; justify-content: flex-end; padding-bottom: 10px; } .dx-tabs .dx-tabs-wrapper .dx-tab { width: auto; padding-left: 20px; } .dx-sortable-dragging .dx-tab { box-sizing: border-box; text-align: center; } .employeeInfo .employeePhoto { height: 100px; float: left; padding: 10px 20px; } .caption { padding: 0 0 10px 30px; font-size: 14px; font-weight: bold; } .task-list { padding: 0 20px; } .task-list.dx-state-disabled { opacity: 1; } .task-list.dx-state-disabled .dx-list-item { opacity: 1; } .employeeInfo .employeeNotes { min-height: 100px; padding: 20px; text-align: justify; white-space: normal; } .dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab { max-width: fit-content; padding-left: 14px; padding-right: 9px; line-height: 1.618; } .dx-tabpanel .dx-tab .dx-icon.dx-icon-close { display: inline-block; margin-right: 0; margin-left: 7px; opacity: 0.6; } .dx-theme-generic .dx-tabpanel .dx-tab .dx-icon.dx-icon-close { font-size: 15px; } .dx-theme-material .dx-tabpanel .dx-tab .dx-icon.dx-icon-close { font-size: 18px; } .dx-theme-material .dx-tab-content { flex-direction: row; } .dx-theme-material .employeeNotes { margin: 0; }
const employees = [{ ID: 1, FirstName: 'John', LastName: 'Heart', Prefix: 'Mr.', Position: 'CEO', Picture: '../../../../images/employees/01.png', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St.', State: 'California', City: 'Los Angeles', }, { ID: 2, FirstName: 'Olivia', LastName: 'Peyton', Prefix: 'Mrs.', Position: 'Sales Assistant', Picture: '../../../../images/employees/09.png', BirthDate: '1981/06/03', HireDate: '2012/05/14', Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.', Address: '807 W Paseo Del Mar', State: 'California', City: 'Los Angeles', }, { ID: 3, FirstName: 'Robert', LastName: 'Reagan', Prefix: 'Mr.', Position: 'CMO', Picture: '../../../../images/employees/03.png', BirthDate: '1974/09/07', HireDate: '2002/11/08', Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.', Address: '4 Westmoreland Pl.', State: 'Arkansas', City: 'Bentonville', }, { ID: 4, FirstName: 'Greta', LastName: 'Sims', Prefix: 'Ms.', Position: 'HR Manager', Picture: '../../../../images/employees/04.png', BirthDate: '1977/11/22', HireDate: '1998/04/23', Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.", Address: '1700 S Grandview Dr.', State: 'Georgia', City: 'Atlanta', }, { ID: 5, FirstName: 'Brett', LastName: 'Wade', Prefix: 'Mr.', Position: 'IT Manager', Picture: '../../../../images/employees/05.png', BirthDate: '1968/12/01', HireDate: '2009/03/06', Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).', Address: '1120 Old Mill Rd.', State: 'Idaho', City: 'Boise', }, { ID: 6, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', Picture: '../../../../images/employees/06.png', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.", Address: '4600 N Virginia Rd.', State: 'Utah', City: 'Beaver', }, { ID: 7, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', Picture: '../../../../images/employees/07.png', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', State: 'California', City: 'San Diego', }, { ID: 8, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', Picture: '../../../../images/employees/08.png', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', State: 'Arkansas', City: 'Little Rock', }, { ID: 9, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', Picture: '../../../../images/employees/02.png', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', State: 'Missouri', City: 'St. Louis', }]; const tasks = [{ ID: 1, Subject: 'Prepare 2013 Financial', StartDate: '2013/01/15', DueDate: '2013/01/31', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 8, }, { ID: 2, Subject: 'Prepare 3013 Marketing Plan', StartDate: '2013/01/01', DueDate: '2013/01/31', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 5, }, { ID: 3, Subject: 'Update Personnel Files', StartDate: '2013/02/03', DueDate: '2013/02/28', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 2, }, { ID: 4, Subject: 'Review Health Insurance Options Under the Affordable Care Act', StartDate: '2013/02/12', DueDate: '2013/04/25', Status: 'In Progress', Priority: 'High', Completion: 50, EmployeeID: 2, }, { ID: 5, Subject: 'Choose between PPO and HMO Health Plan', StartDate: '2013/02/15', DueDate: '2013/04/15', Status: 'In Progress', Priority: 'High', Completion: 75, EmployeeID: 1, }, { ID: 6, Subject: 'Google AdWords Strategy', StartDate: '2013/02/16', DueDate: '2013/02/28', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 1, }, { ID: 7, Subject: 'New Brochures', StartDate: '2013/02/17', DueDate: '2013/02/24', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 1, }, { ID: 11, Subject: 'Rollout of New Website and Marketing Brochures', StartDate: '2013/02/20', DueDate: '2013/02/28', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 5, }, { ID: 12, Subject: 'Update Sales Strategy Documents', StartDate: '2013/02/20', DueDate: '2013/02/22', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 9, }, { ID: 15, Subject: 'Review 2012 Sales Report and Approve 2013 Plans', StartDate: '2013/02/23', DueDate: '2013/02/28', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 5, }, { ID: 16, Subject: 'Deliver R&D Plans for 2013', StartDate: '2013/03/01', DueDate: '2013/03/10', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 3, }, { ID: 20, Subject: 'Approve Hiring of John Jeffers', StartDate: '2013/03/02', DueDate: '2013/03/12', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 4, }, { ID: 20, Subject: 'Approve Hiring of John Jeffers', StartDate: '2013/03/02', DueDate: '2013/03/12', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 6, }, { ID: 21, Subject: 'Non-Compete Agreements', StartDate: '2013/03/12', DueDate: '2013/03/14', Status: 'Completed', Priority: 'Low', Completion: 100, EmployeeID: 2, }, { ID: 22, Subject: 'Update NDA Agreement', StartDate: '2013/03/14', DueDate: '2013/03/16', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 1, }, { ID: 23, Subject: 'Update Employee Files with New NDA', StartDate: '2013/03/16', DueDate: '2013/03/26', Status: 'Need Assistance', Priority: 'Normal', Completion: 90, EmployeeID: 4, }, { ID: 24, Subject: 'Update Employee Files with New NDA', StartDate: '2013/03/16', DueDate: '2013/03/26', Status: 'Need Assistance', Priority: 'Normal', Completion: 90, EmployeeID: 6, }, { ID: 25, Subject: 'Sign Updated NDA', StartDate: '2013/03/20', DueDate: '2013/03/25', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 7, }, { ID: 26, Subject: 'Sign Updated NDA', StartDate: '2013/03/20', DueDate: '2013/03/25', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 8, }, { ID: 27, Subject: 'Sign Updated NDA', StartDate: '2013/03/20', DueDate: '2013/03/25', Status: 'Need Assistance', Priority: 'Urgent', Completion: 25, EmployeeID: 9, }, { ID: 35, Subject: 'Update Revenue Projections', StartDate: '2013/03/24', DueDate: '2013/04/07', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 8, }, { ID: 36, Subject: 'Review Revenue Projections', StartDate: '2013/03/25', DueDate: '2013/04/06', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 9, }, { ID: 40, Subject: 'Provide New Health Insurance Docs', StartDate: '2013/03/28', DueDate: '2013/04/07', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 4, }, { ID: 41, Subject: 'Provide New Health Insurance Docs', StartDate: '2013/03/28', DueDate: '2013/04/07', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 6, }, { ID: 50, Subject: 'Give Final Approval for Refunds', StartDate: '2013/05/05', DueDate: '2013/05/15', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 2, }, { ID: 52, Subject: 'Review Product Recall Report by Engineering Team', StartDate: '2013/05/17', DueDate: '2013/05/20', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 1, }, { ID: 55, Subject: 'Review Overtime Report', StartDate: '2013/06/10', DueDate: '2013/06/14', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 7, }, { ID: 60, Subject: 'Refund Request Template', StartDate: '2013/06/17', DueDate: '2014/04/01', Status: 'Deferred', Priority: 'Normal', Completion: 0, EmployeeID: 9, }, { ID: 71, Subject: 'Upgrade Server Hardware', StartDate: '2013/07/22', DueDate: '2013/07/31', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 7, }, { ID: 72, Subject: 'Upgrade Personal Computers', StartDate: '2013/07/24', DueDate: '2014/04/30', Status: 'In Progress', Priority: 'Normal', Completion: 85, EmployeeID: 7, }, { ID: 74, Subject: 'Decide on Mobile Devices to Use in the Field', StartDate: '2013/07/30', DueDate: '2013/08/02', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 3, }, { ID: 78, Subject: 'Try New Touch-Enabled WinForms Apps', StartDate: '2013/08/11', DueDate: '2013/08/15', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 3, }, { ID: 81, Subject: 'Review Site Up-Time Report', StartDate: '2013/08/24', DueDate: '2013/08/30', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 5, }, { ID: 99, Subject: 'Submit D&B Number to ISP for Credit Approval', StartDate: '2013/11/04', DueDate: '2013/11/07', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 8, }, { ID: 117, Subject: 'Approval on Converting to New HDMI Specification', StartDate: '2014/01/11', DueDate: '2014/01/31', Status: 'Deferred', Priority: 'Normal', Completion: 75, EmployeeID: 3, }, { ID: 138, Subject: 'Review HR Budget Company Wide', StartDate: '2014/03/20', DueDate: '2014/03/25', Status: 'In Progress', Priority: 'Normal', Completion: 40, EmployeeID: 6, }, { ID: 145, Subject: 'Final Budget Review', StartDate: '2014/03/26', DueDate: '2014/03/27', Status: 'In Progress', Priority: 'High', Completion: 25, EmployeeID: 6, }];

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Tab Panel - Drag & Drop

This demo illustrates how you can allow end-users to reorder, add, and remove tabs within the DevExtreme TabPanel component.

Backend API
<template> <div> <div id="container"> <DxButton :disabled="disableButton()" text="Add Tab" icon="add" type="default" @click="addButtonHandler" /> </div> <DxSortable filter=".dx-tab" v-model:data="employees" item-orientation="horizontal" drag-direction="horizontal" @drag-start="onTabDragStart($event)" @reorder="onTabDrop($event)" > <div> <DxTabPanel v-model:data-source="employees" :height="410" :defer-rendering="false" :show-nav-buttons="true" :repaint-changes-only="true" v-model:selected-index="selectedIndex" item-title-template="itemTitle" item-template="itemTemplate" > <template #itemTitle="{ data: employee }"> <div> <span>{{ employee.FirstName }} {{ employee.LastName }}</span><i v-show="showCloseButton()" class="dx-icon dx-icon-close" @click="closeButtonHandler(employee)" /> </div> </template> <template #itemTemplate="{ data: employee }"> <EmployeeTemplate :employee="employee" /> </template> </DxTabPanel> </div> </DxSortable> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxSortable, { type DxSortableTypes } from 'devextreme-vue/sortable'; import DxButton from 'devextreme-vue/button'; import DxTabPanel from 'devextreme-vue/tab-panel'; import EmployeeTemplate from './EmployeeTemplate.vue'; import service, { type Employee } from './data.ts'; const allEmployees = service.getEmployees(); const employees = ref<Employee[]>(allEmployees.slice(0, 3)); const selectedIndex = ref(0); function onTabDragStart(e: DxSortableTypes.DragStartEvent) { e.itemData = e.fromData[e.fromIndex]; } function onTabDrop(e: DxSortableTypes.ReorderEvent) { const newEmployees = [...employees.value]; newEmployees.splice(e.fromIndex, 1); newEmployees.splice(e.toIndex, 0, e.itemData); employees.value = newEmployees; } function addButtonHandler() { const newItem = allEmployees .filter((employee) => employees.value.every((item) => employee.ID !== item.ID))[0]; selectedIndex.value = employees.value.length; employees.value = [...employees.value, newItem]; } function closeButtonHandler(itemData: Employee) { const index = employees.value.indexOf(itemData); employees.value = employees.value.filter((e: Employee) => e !== itemData); if (index >= employees.value.length && index > 0) selectedIndex.value = index - 1; } function disableButton() { return employees.value.length === allEmployees.length; } function showCloseButton() { return employees.value.length > 1; } </script> <style> #container { display: flex; justify-content: flex-end; padding-bottom: 10px; } .dx-tabs .dx-tabs-wrapper .dx-item.dx-tab { width: auto; padding-left: 20px; } .dx-sortable-dragging .dx-tab { box-sizing: border-box; text-align: center; } .employeeInfo .employeePhoto { height: 100px; float: left; padding: 10px 20px; } .employeeInfo .employeeNotes { min-height: 100px; padding: 20px; text-align: justify; white-space: normal; } .dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab { max-width: fit-content; padding-left: 14px; padding-right: 9px; line-height: 1.618; } .dx-tabpanel .dx-tab .dx-icon.dx-icon-close { display: inline-block; margin-right: 0; margin-left: 7px; opacity: 0.6; } .dx-theme-generic .dx-tabpanel .dx-tab .dx-icon.dx-icon-close { font-size: 15px; } .dx-theme-material .dx-tabpanel .dx-tab .dx-icon.dx-icon-close { font-size: 18px; } .dx-theme-material .dx-tab-content { flex-direction: row; } .dx-theme-material .employeeNotes { margin: 0; } </style>
<template> <div> <div class="employeeInfo"> <img class="employeePhoto" :alt="employee.FirstName + ' ' + employee.LastName" :src="employee.Picture" > <p class="employeeNotes"><b>Position: {{ employee.Position }}</b><br>{{ employee.Notes }}</p> </div> <div class="caption">{{ employee.FirstName }} {{ employee.LastName }}'s Tasks: </div> <div class="task-list"> <DxList :data-source="dataSource" :show-selection-controls="true" :selected-items="completedTasks" :disabled="true" selection-mode="multiple" > <template #item="{ data: item }"> <div> {{ item.Subject }} </div> </template> </DxList> </div> </div> </template> <script setup lang="ts"> import DxList from 'devextreme-vue/list'; import service from './data.ts'; const props = withDefaults(defineProps<{ employee?: Record<string, any> }>(), { employee: () => ({} as Record<string, any>), }); const tasks = service.getTasks(); const employeeTasks = tasks.filter(({ EmployeeID }) => EmployeeID === props.employee.ID); const dataSource = employeeTasks; const completedTasks = employeeTasks.filter(({ Status }) => Status === 'Completed'); </script> <style> .caption { padding: 0 0 10px 30px; font-size: 14px; font-weight: bold; } .task-list { padding: 0 20px; } .task-list .dx-state-disabled { opacity: 1; } .task-list .dx-state-disabled .dx-list-item { opacity: 1; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
export interface Employee { ID: number, FirstName: string, LastName: string, Prefix: string, Position: string, Picture: string, BirthDate: string, HireDate: string, Notes: string, Address: string, State: string, City: string, } const employees = [{ ID: 1, FirstName: 'John', LastName: 'Heart', Prefix: 'Mr.', Position: 'CEO', Picture: '../../../../images/employees/01.png', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St.', State: 'California', City: 'Los Angeles', }, { ID: 2, FirstName: 'Olivia', LastName: 'Peyton', Prefix: 'Mrs.', Position: 'Sales Assistant', Picture: '../../../../images/employees/09.png', BirthDate: '1981/06/03', HireDate: '2012/05/14', Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.', Address: '807 W Paseo Del Mar', State: 'California', City: 'Los Angeles', }, { ID: 3, FirstName: 'Robert', LastName: 'Reagan', Prefix: 'Mr.', Position: 'CMO', Picture: '../../../../images/employees/03.png', BirthDate: '1974/09/07', HireDate: '2002/11/08', Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.', Address: '4 Westmoreland Pl.', State: 'Arkansas', City: 'Bentonville', }, { ID: 4, FirstName: 'Greta', LastName: 'Sims', Prefix: 'Ms.', Position: 'HR Manager', Picture: '../../../../images/employees/04.png', BirthDate: '1977/11/22', HireDate: '1998/04/23', Notes: 'Greta has been DevAV\'s HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.', Address: '1700 S Grandview Dr.', State: 'Georgia', City: 'Atlanta', }, { ID: 5, FirstName: 'Brett', LastName: 'Wade', Prefix: 'Mr.', Position: 'IT Manager', Picture: '../../../../images/employees/05.png', BirthDate: '1968/12/01', HireDate: '2009/03/06', Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).', Address: '1120 Old Mill Rd.', State: 'Idaho', City: 'Boise', }, { ID: 6, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', Picture: '../../../../images/employees/06.png', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: 'Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you\'ve not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.', Address: '4600 N Virginia Rd.', State: 'Utah', City: 'Beaver', }, { ID: 7, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', Picture: '../../../../images/employees/07.png', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', State: 'California', City: 'San Diego', }, { ID: 8, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', Picture: '../../../../images/employees/08.png', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', State: 'Arkansas', City: 'Little Rock', }, { ID: 9, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', Picture: '../../../../images/employees/02.png', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', State: 'Missouri', City: 'St. Louis', }]; const tasks = [{ ID: 1, Subject: 'Prepare 2013 Financial', StartDate: '2013/01/15', DueDate: '2013/01/31', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 8, }, { ID: 2, Subject: 'Prepare 3013 Marketing Plan', StartDate: '2013/01/01', DueDate: '2013/01/31', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 5, }, { ID: 3, Subject: 'Update Personnel Files', StartDate: '2013/02/03', DueDate: '2013/02/28', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 2, }, { ID: 4, Subject: 'Review Health Insurance Options Under the Affordable Care Act', StartDate: '2013/02/12', DueDate: '2013/04/25', Status: 'In Progress', Priority: 'High', Completion: 50, EmployeeID: 2, }, { ID: 5, Subject: 'Choose between PPO and HMO Health Plan', StartDate: '2013/02/15', DueDate: '2013/04/15', Status: 'In Progress', Priority: 'High', Completion: 75, EmployeeID: 1, }, { ID: 6, Subject: 'Google AdWords Strategy', StartDate: '2013/02/16', DueDate: '2013/02/28', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 1, }, { ID: 7, Subject: 'New Brochures', StartDate: '2013/02/17', DueDate: '2013/02/24', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 1, }, { ID: 11, Subject: 'Rollout of New Website and Marketing Brochures', StartDate: '2013/02/20', DueDate: '2013/02/28', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 5, }, { ID: 12, Subject: 'Update Sales Strategy Documents', StartDate: '2013/02/20', DueDate: '2013/02/22', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 9, }, { ID: 15, Subject: 'Review 2012 Sales Report and Approve 2013 Plans', StartDate: '2013/02/23', DueDate: '2013/02/28', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 5, }, { ID: 16, Subject: 'Deliver R&D Plans for 2013', StartDate: '2013/03/01', DueDate: '2013/03/10', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 3, }, { ID: 20, Subject: 'Approve Hiring of John Jeffers', StartDate: '2013/03/02', DueDate: '2013/03/12', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 4, }, { ID: 20, Subject: 'Approve Hiring of John Jeffers', StartDate: '2013/03/02', DueDate: '2013/03/12', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 6, }, { ID: 21, Subject: 'Non-Compete Agreements', StartDate: '2013/03/12', DueDate: '2013/03/14', Status: 'Completed', Priority: 'Low', Completion: 100, EmployeeID: 2, }, { ID: 22, Subject: 'Update NDA Agreement', StartDate: '2013/03/14', DueDate: '2013/03/16', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 1, }, { ID: 23, Subject: 'Update Employee Files with New NDA', StartDate: '2013/03/16', DueDate: '2013/03/26', Status: 'Need Assistance', Priority: 'Normal', Completion: 90, EmployeeID: 4, }, { ID: 24, Subject: 'Update Employee Files with New NDA', StartDate: '2013/03/16', DueDate: '2013/03/26', Status: 'Need Assistance', Priority: 'Normal', Completion: 90, EmployeeID: 6, }, { ID: 25, Subject: 'Sign Updated NDA', StartDate: '2013/03/20', DueDate: '2013/03/25', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 7, }, { ID: 26, Subject: 'Sign Updated NDA', StartDate: '2013/03/20', DueDate: '2013/03/25', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 8, }, { ID: 27, Subject: 'Sign Updated NDA', StartDate: '2013/03/20', DueDate: '2013/03/25', Status: 'Need Assistance', Priority: 'Urgent', Completion: 25, EmployeeID: 9, }, { ID: 35, Subject: 'Update Revenue Projections', StartDate: '2013/03/24', DueDate: '2013/04/07', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 8, }, { ID: 36, Subject: 'Review Revenue Projections', StartDate: '2013/03/25', DueDate: '2013/04/06', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 9, }, { ID: 40, Subject: 'Provide New Health Insurance Docs', StartDate: '2013/03/28', DueDate: '2013/04/07', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 4, }, { ID: 41, Subject: 'Provide New Health Insurance Docs', StartDate: '2013/03/28', DueDate: '2013/04/07', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 6, }, { ID: 50, Subject: 'Give Final Approval for Refunds', StartDate: '2013/05/05', DueDate: '2013/05/15', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 2, }, { ID: 52, Subject: 'Review Product Recall Report by Engineering Team', StartDate: '2013/05/17', DueDate: '2013/05/20', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 1, }, { ID: 55, Subject: 'Review Overtime Report', StartDate: '2013/06/10', DueDate: '2013/06/14', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 7, }, { ID: 60, Subject: 'Refund Request Template', StartDate: '2013/06/17', DueDate: '2014/04/01', Status: 'Deferred', Priority: 'Normal', Completion: 0, EmployeeID: 9, }, { ID: 71, Subject: 'Upgrade Server Hardware', StartDate: '2013/07/22', DueDate: '2013/07/31', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 7, }, { ID: 72, Subject: 'Upgrade Personal Computers', StartDate: '2013/07/24', DueDate: '2014/04/30', Status: 'In Progress', Priority: 'Normal', Completion: 85, EmployeeID: 7, }, { ID: 74, Subject: 'Decide on Mobile Devices to Use in the Field', StartDate: '2013/07/30', DueDate: '2013/08/02', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 3, }, { ID: 78, Subject: 'Try New Touch-Enabled WinForms Apps', StartDate: '2013/08/11', DueDate: '2013/08/15', Status: 'Completed', Priority: 'Normal', Completion: 100, EmployeeID: 3, }, { ID: 81, Subject: 'Review Site Up-Time Report', StartDate: '2013/08/24', DueDate: '2013/08/30', Status: 'Completed', Priority: 'Urgent', Completion: 100, EmployeeID: 5, }, { ID: 99, Subject: 'Submit D&B Number to ISP for Credit Approval', StartDate: '2013/11/04', DueDate: '2013/11/07', Status: 'Completed', Priority: 'High', Completion: 100, EmployeeID: 8, }, { ID: 117, Subject: 'Approval on Converting to New HDMI Specification', StartDate: '2014/01/11', DueDate: '2014/01/31', Status: 'Deferred', Priority: 'Normal', Completion: 75, EmployeeID: 3, }, { ID: 138, Subject: 'Review HR Budget Company Wide', StartDate: '2014/03/20', DueDate: '2014/03/25', Status: 'In Progress', Priority: 'Normal', Completion: 40, EmployeeID: 6, }, { ID: 145, Subject: 'Final Budget Review', StartDate: '2014/03/26', DueDate: '2014/03/27', Status: 'In Progress', Priority: 'High', Completion: 25, EmployeeID: 6, }]; export default { getEmployees() { return employees; }, getTasks() { return tasks; }, };
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Reorder tabs

Wrap the TabPanel into the Sortable component and set the following properties as needed:

  • filter
    Specify a CSS selector to indicate draggable items. This demo sets filter to .dx-tab.

  • itemOrientation
    Set this property to "horizontal". When a user drags a tab, remaining items move left and right to designate the drop target.

  • onDragStart and onReorder
    Implement these handlers to configure drag and drop logic and modify the dataSource after the tabs are reordered.

Add or remove tabs

This demo adds and removes tabs in the following two functions:

  • addButtonHandler - a click handler for the "Add Tab" button.
  • closeButtonHandler - a click handler for a tab's Close icon. The demo uses the itemTitleTemplate property to display this icon.

Both handlers modify the TabPanel's dataSource.

import React, { useCallback, useState } from 'react';
import Button from 'devextreme-react/button';
import Sortable, { type SortableTypes } from 'devextreme-react/sortable';
import TabPanel, { type TabPanelTypes } from 'devextreme-react/tab-panel';
import { employees as allEmployees } from './data.ts';
import type { Employee } from './types.ts';
import EmployeeTemplate from './EmployeeTemplate.tsx';
function App() {
const [employees, setEmployees] = useState<Employee[]>(allEmployees.slice(0, 3));
const [selectedItem, setSelectedItem] = useState<Employee>(allEmployees[0]);
const addButtonHandler = useCallback(() => {
const newItem = allEmployees
.filter((employee: Employee): boolean => employees.indexOf(employee) === -1)[0];
setEmployees([...employees, newItem]);
setSelectedItem(newItem);
}, [employees]);
function disableButton(): boolean {
return employees.length === allEmployees.length;
}
const closeButtonHandler = useCallback((item: Employee): void => {
const newEmployees = [...employees];
const index = newEmployees.indexOf(item);
newEmployees.splice(index, 1);
setEmployees(newEmployees);
if (index >= newEmployees.length && index > 0) {
setSelectedItem(newEmployees[index - 1]);
}
}, [employees]);
const renderTitle = useCallback((data: Employee) => (
<>
<span>
{data.FirstName} {data.LastName}
</span>
{employees.length >= 2 && <i className="dx-icon dx-icon-close" onClick={(): void => { closeButtonHandler(data); }} />}
</>
), [employees, closeButtonHandler]);
const onSelectionChanged = useCallback((args: TabPanelTypes.SelectionChangedEvent): void => {
setSelectedItem(args.addedItems[0]);
}, [setSelectedItem]);
const onTabDragStart = useCallback((e: SortableTypes.DragStartEvent): void => {
e.itemData = e.fromData[e.fromIndex];
}, []);
const onTabDrop = useCallback((e: SortableTypes.ReorderEvent): void => {
const newEmployees = [...employees];
newEmployees.splice(e.fromIndex, 1);
newEmployees.splice(e.toIndex, 0, e.itemData);
setEmployees(newEmployees);
}, [employees, setEmployees]);
return (
<>
<div id="container">
<Button
disabled={disableButton()}
text="Add Tab"
icon="add"
type="default"
onClick={addButtonHandler}
/>
</div>
<Sortable
filter=".dx-tab"
data={employees}
itemOrientation="horizontal"
dragDirection="horizontal"
onDragStart={onTabDragStart}
onReorder={onTabDrop}
>
<TabPanel
dataSource={employees}
height={410}
itemTitleRender={renderTitle}
deferRendering={false}
showNavButtons={true}
selectedItem={selectedItem}
repaintChangesOnly={true}
onSelectionChanged={onSelectionChanged}
itemComponent={EmployeeTemplate}
/>
</Sortable>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import Button from 'devextreme-react/button';
import Sortable from 'devextreme-react/sortable';
import TabPanel from 'devextreme-react/tab-panel';
import { employees as allEmployees } from './data.js';
import EmployeeTemplate from './EmployeeTemplate.js';
function App() {
const [employees, setEmployees] = useState(allEmployees.slice(0, 3));
const [selectedItem, setSelectedItem] = useState(allEmployees[0]);
const addButtonHandler = useCallback(() => {
const newItem = allEmployees.filter((employee) => employees.indexOf(employee) === -1)[0];
setEmployees([...employees, newItem]);
setSelectedItem(newItem);
}, [employees]);
function disableButton() {
return employees.length === allEmployees.length;
}
const closeButtonHandler = useCallback(
(item) => {
const newEmployees = [...employees];
const index = newEmployees.indexOf(item);
newEmployees.splice(index, 1);
setEmployees(newEmployees);
if (index >= newEmployees.length && index > 0) {
setSelectedItem(newEmployees[index - 1]);
}
},
[employees],
);
const renderTitle = useCallback(
(data) => (
<>
<span>
{data.FirstName} {data.LastName}
</span>
{employees.length >= 2 && (
<i
className="dx-icon dx-icon-close"
onClick={() => {
closeButtonHandler(data);
}}
/>
)}
</>
),
[employees, closeButtonHandler],
);
const onSelectionChanged = useCallback(
(args) => {
setSelectedItem(args.addedItems[0]);
},
[setSelectedItem],
);
const onTabDragStart = useCallback((e) => {
e.itemData = e.fromData[e.fromIndex];
}, []);
const onTabDrop = useCallback(
(e) => {
const newEmployees = [...employees];
newEmployees.splice(e.fromIndex, 1);
newEmployees.splice(e.toIndex, 0, e.itemData);
setEmployees(newEmployees);
},
[employees, setEmployees],
);
return (
<>
<div id="container">
<Button
disabled={disableButton()}
text="Add Tab"
icon="add"
type="default"
onClick={addButtonHandler}
/>
</div>
<Sortable
filter=".dx-tab"
data={employees}
itemOrientation="horizontal"
dragDirection="horizontal"
onDragStart={onTabDragStart}
onReorder={onTabDrop}
>
<TabPanel
dataSource={employees}
height={410}
itemTitleRender={renderTitle}
deferRendering={false}
showNavButtons={true}
selectedItem={selectedItem}
repaintChangesOnly={true}
onSelectionChanged={onSelectionChanged}
itemComponent={EmployeeTemplate}
/>
</Sortable>
</>
);
}
export default App;
import React from 'react';
import { List } from 'devextreme-react/list';
import { tasks } from './data.ts';
import type { Employee, Task } from './types.ts';
function itemRender(data: Task) {
return <div>{data.Subject}</div>;
}
interface EmployeeTemplateProps {
data: Employee;
}
function EmployeeTemplate({ data }: EmployeeTemplateProps) {
const employeeTasks = tasks.filter((task: { EmployeeID: any; }) => task.EmployeeID === data.ID);
const {
FirstName,
LastName,
Picture,
Position,
Notes,
} = data;
const completedTasks = employeeTasks.filter((task: { Status: string; }) => task.Status === 'Completed');
return (
<>
<div className="employeeInfo">
<img alt={`${FirstName} ${LastName}`} className="employeePhoto" src={Picture} />
<p className="employeeNotes">
<b>{`Position: ${Position}`}</b>
<br />
{Notes}
</p>
</div>
<div className="caption">{`${FirstName} ${LastName}'s Tasks:`}</div>
<div className="task-list">
<List
dataSource={employeeTasks}
showSelectionControls={true}
selectedItems={completedTasks}
disabled={true}
selectionMode="multiple"
itemRender={itemRender}
></List>
</div>
</>
);
}
export default EmployeeTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Employee, Task } from './types.ts';
export const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: 'Greta has been DevAV\'s HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.',
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: 'Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you\'ve not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.',
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
}];
export const tasks: Task[] = [{
ID: 1,
Subject: 'Prepare 2023 Financial',
StartDate: '2023/01/15',
DueDate: '2023/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 2023 Marketing Plan',
StartDate: '2023/01/01',
DueDate: '2023/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2023/02/03',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2023/02/12',
DueDate: '2023/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2023/02/15',
DueDate: '2023/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2023/02/16',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2023/02/17',
DueDate: '2023/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2023/02/20',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2023/02/20',
DueDate: '2023/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2022 Sales Report and Approve 2023 Plans',
StartDate: '2023/02/23',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2023',
StartDate: '2023/03/01',
DueDate: '2023/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2023/03/02',
DueDate: '2023/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2023/03/02',
DueDate: '2023/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2023/03/12',
DueDate: '2023/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2023/03/14',
DueDate: '2023/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2023/03/16',
DueDate: '2023/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2023/03/16',
DueDate: '2023/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2023/03/20',
DueDate: '2023/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2023/03/20',
DueDate: '2023/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2023/03/20',
DueDate: '2023/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2023/03/24',
DueDate: '2023/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2023/03/25',
DueDate: '2023/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2023/03/28',
DueDate: '2023/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2023/03/28',
DueDate: '2023/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2023/05/05',
DueDate: '2023/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2023/05/17',
DueDate: '2023/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2023/06/10',
DueDate: '2023/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2023/06/17',
DueDate: '2024/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2023/07/22',
DueDate: '2023/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2023/07/24',
DueDate: '2024/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2023/07/30',
DueDate: '2023/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2023/08/11',
DueDate: '2023/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2023/08/24',
DueDate: '2023/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2023/11/04',
DueDate: '2023/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2024/01/11',
DueDate: '2024/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2024/03/20',
DueDate: '2024/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2024/03/26',
DueDate: '2024/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];
export type Employee = {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
Picture: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
State: string;
City: string;
};
export type Task = {
ID: number;
Subject: string;
StartDate: string;
DueDate: string;
Status: string;
Priority: string;
Completion: number;
EmployeeID: number;
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.31/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.70/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import { List } from 'devextreme-react/list';
import { tasks } from './data.js';
function itemRender(data) {
return <div>{data.Subject}</div>;
}
function EmployeeTemplate({ data }) {
const employeeTasks = tasks.filter((task) => task.EmployeeID === data.ID);
const {
FirstName, LastName, Picture, Position, Notes,
} = data;
const completedTasks = employeeTasks.filter((task) => task.Status === 'Completed');
return (
<>
<div className="employeeInfo">
<img
alt={`${FirstName} ${LastName}`}
className="employeePhoto"
src={Picture}
/>
<p className="employeeNotes">
<b>{`Position: ${Position}`}</b>
<br />
{Notes}
</p>
</div>
<div className="caption">{`${FirstName} ${LastName}'s Tasks:`}</div>
<div className="task-list">
<List
dataSource={employeeTasks}
showSelectionControls={true}
selectedItems={completedTasks}
disabled={true}
selectionMode="multiple"
itemRender={itemRender}
></List>
</div>
</>
);
}
export default EmployeeTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employees = [
{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes:
'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
},
{
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes:
'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
},
{
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes:
'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
},
{
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes:
"Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
},
{
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes:
'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
},
{
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes:
"Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
},
{
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes:
'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
},
{
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes:
'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
},
{
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes:
'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
},
];
export const tasks = [
{
ID: 1,
Subject: 'Prepare 2023 Financial',
StartDate: '2023/01/15',
DueDate: '2023/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 2023 Marketing Plan',
StartDate: '2023/01/01',
DueDate: '2023/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2023/02/03',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2023/02/12',
DueDate: '2023/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2023/02/15',
DueDate: '2023/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2023/02/16',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2023/02/17',
DueDate: '2023/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2023/02/20',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2023/02/20',
DueDate: '2023/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2022 Sales Report and Approve 2023 Plans',
StartDate: '2023/02/23',
DueDate: '2023/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2023',
StartDate: '2023/03/01',
DueDate: '2023/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2023/03/02',
DueDate: '2023/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2023/03/02',
DueDate: '2023/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2023/03/12',
DueDate: '2023/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2023/03/14',
DueDate: '2023/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2023/03/16',
DueDate: '2023/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2023/03/16',
DueDate: '2023/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2023/03/20',
DueDate: '2023/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2023/03/20',
DueDate: '2023/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2023/03/20',
DueDate: '2023/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2023/03/24',
DueDate: '2023/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2023/03/25',
DueDate: '2023/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2023/03/28',
DueDate: '2023/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2023/03/28',
DueDate: '2023/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2023/05/05',
DueDate: '2023/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2023/05/17',
DueDate: '2023/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2023/06/10',
DueDate: '2023/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2023/06/17',
DueDate: '2024/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2023/07/22',
DueDate: '2023/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2023/07/24',
DueDate: '2024/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2023/07/30',
DueDate: '2023/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2023/08/11',
DueDate: '2023/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2023/08/24',
DueDate: '2023/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2023/11/04',
DueDate: '2023/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2024/01/11',
DueDate: '2024/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2024/03/20',
DueDate: '2024/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2024/03/26',
DueDate: '2024/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#container {
display: flex;
justify-content: flex-end;
padding-bottom: 10px;
}
.dx-tabs .dx-tabs-wrapper .dx-item.dx-tab {
width: auto;
padding-left: 20px;
}
.dx-sortable-dragging .dx-tab {
box-sizing: border-box;
text-align: center;
}
.employeeInfo .employeePhoto {
height: 100px;
float: left;
padding: 10px 20px;
}
.caption {
padding: 0 0 10px 30px;
font-size: 14px;
font-weight: bold;
}
.task-list {
padding: 0 20px;
}
.task-list .dx-state-disabled {
opacity: 1;
}
.task-list .dx-state-disabled .dx-list-item {
opacity: 1;
}
.employeeInfo .employeeNotes {
min-height: 100px;
padding: 20px;
text-align: justify;
white-space: normal;
}
.dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab {
max-width: fit-content;
padding-left: 14px;
padding-right: 9px;
line-height: 1.618;
}
.dx-tabpanel .dx-tab .dx-icon.dx-icon-close {
display: inline-block;
margin-right: 0;
margin-left: 7px;
opacity: 0.6;
}
.dx-theme-generic .dx-tabpanel .dx-tab .dx-icon.dx-icon-close {
font-size: 15px;
}
.dx-theme-material .dx-tabpanel .dx-tab .dx-icon.dx-icon-close {
font-size: 18px;
}
.dx-theme-material .dx-tab-content {
flex-direction: row;
}
.dx-theme-material .employeeNotes {
margin: 0;
}

Backend API
<div id="container">
<dx-button
[disabled]="disableButton()"
text="Add Tab"
icon="add"
type="default"
(onClick)="addButtonHandler()"
></dx-button>
</div>
<dx-sortable
filter=".dx-tab"
[data]="employees"
itemOrientation="horizontal"
dragDirection="horizontal"
(onDragStart)="onTabDragStart($event)"
(onReorder)="onTabDrop($event)"
>
<dx-tab-panel
[dataSource]="employees"
[height]="410"
itemTitleTemplate="title"
itemTemplate="item"
[deferRendering]="false"
[showNavButtons]="true"
[repaintChangesOnly]="true"
[selectedIndex]="selectedIndex"
>
<div *dxTemplate="let content of 'title'">
<span>{{ content.FirstName }} {{ content.LastName }}</span
><i
*ngIf="showCloseButton()"
class="dx-icon dx-icon-close"
(click)="closeButtonHandler(content)"
></i>
</div>
<div *dxTemplate="let employee of 'item'">
<div class="employeeInfo">
<img
alt="{{ employee.FirstName }} {{ employee.LastName }}"
class="employeePhoto"
[src]="employee.Picture"
/>
<p class="employeeNotes"
><b>Position: {{ employee.Position }}</b
><br />{{ employee.Notes }}</p
>
</div>
<div class="caption">{{
employee.FirstName + " " + employee.LastName + "'s Tasks:"
}}</div>
<div class="task-list">
<dx-list
[dataSource]="getTasks(employee.ID)"
[showSelectionControls]="true"
[selectedItems]="getCompletedTasks(employee.ID)"
[disabled]="true"
selectionMode="multiple"
>
<div *dxTemplate="let item of 'item'">
<div>{{ item.Subject }}</div>
</div>
</dx-list>
</div>
</div>
</dx-tab-panel>
</dx-sortable>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxButtonModule, DxSortableModule, DxTabPanelModule, DxListModule, DxTemplateModule,
} from 'devextreme-angular';
import { DxSortableTypes } from 'devextreme-angular/ui/sortable';
import { Employee, Service, Task } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
})
export class AppComponent {
allEmployees: Employee[];
employees: Employee[];
selectedIndex: number;
tasks: Task[];
tasksDataSourceStorage: { key: number, dataSourceInstance: Task[] }[] = [];
constructor(private service: Service) {
this.allEmployees = service.getEmployees();
this.employees = service.getEmployees().slice(0, 3);
this.selectedIndex = 0;
this.tasks = service.getTasks();
}
onTabDragStart(e: DxSortableTypes.DragStartEvent) {
e.itemData = e.fromData[e.fromIndex];
}
onTabDrop(e: DxSortableTypes.ReorderEvent) {
e.fromData.splice(e.fromIndex, 1);
e.toData.splice(e.toIndex, 0, e.itemData);
}
addButtonHandler() {
const newItem = this.allEmployees.filter((employee) => this.employees.indexOf(employee) === -1)[0];
this.selectedIndex = this.employees.length;
this.employees.push(newItem);
}
closeButtonHandler(itemData: Employee) {
const index = this.employees.indexOf(itemData);
this.employees.splice(index, 1);
if (index >= this.employees.length && index > 0) this.selectedIndex = index - 1;
}
showCloseButton() {
return this.employees.length > 1;
}
disableButton() {
return this.employees.length === this.allEmployees.length;
}
getTasks(id: number) {
let item = this.tasksDataSourceStorage.find(
(i) => i.key === id,
);
if (!item) {
item = {
key: id,
dataSourceInstance: this.tasks.filter((task) => task.EmployeeID === id),
};
this.tasksDataSourceStorage.push(item);
}
return item.dataSourceInstance;
}
getCompletedTasks(id: number) {
return this.tasks.filter((task) => task.EmployeeID === id).filter((task) => task.Status === 'Completed');
}
}
@NgModule({
imports: [
BrowserModule,
DxButtonModule,
DxSortableModule,
DxTabPanelModule,
DxListModule,
DxTemplateModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #container {
display: flex;
justify-content: flex-end;
padding-bottom: 10px;
}
::ng-deep .dx-tabs .dx-tabs-wrapper .dx-item.dx-tab {
width: auto;
padding-left: 20px;
}
::ng-deep .dx-sortable-dragging .dx-tab {
box-sizing: border-box;
text-align: center;
}
::ng-deep .employeeInfo .employeePhoto {
height: 100px;
float: left;
padding: 10px 20px;
}
.caption {
padding: 0 0 10px 30px;
font-size: 14px;
font-weight: bold;
}
::ng-deep .task-list {
padding: 0 20px;
}
::ng-deep .task-list .dx-state-disabled {
opacity: 1;
}
::ng-deep .task-list .dx-state-disabled .dx-list-item {
opacity: 1;
}
::ng-deep .employeeInfo .employeeNotes {
min-height: 100px;
padding: 20px;
text-align: justify;
white-space: normal;
}
::ng-deep .dx-theme-generic .dx-tabs-wrapper .dx-item.dx-tab {
max-width: fit-content;
padding-left: 14px;
padding-right: 9px;
line-height: 1.618;
}
::ng-deep .dx-tabpanel .dx-tab .dx-icon.dx-icon-close {
display: inline-block;
margin-right: 0;
margin-left: 7px;
opacity: 0.6;
}
::ng-deep .dx-theme-generic .dx-tabpanel .dx-tab .dx-icon.dx-icon-close {
font-size: 15px;
}
::ng-deep .dx-theme-material .dx-tabpanel .dx-tab .dx-icon.dx-icon-close {
font-size: 18px;
}
::ng-deep .dx-theme-material .dx-tab-content {
flex-direction: row;
}
::ng-deep .dx-theme-material .employeeNotes {
margin: 0;
}
import { Injectable } from '@angular/core';
export class Task {
ID: number;
Subject: string;
StartDate: string;
DueDate: string;
Status: string;
Priority: string;
Completion: number;
EmployeeID: number;
}
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
Picture: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
State: string;
City: string;
}
const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
State: 'California',
City: 'Los Angeles',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
State: 'California',
City: 'Los Angeles',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
State: 'Arkansas',
City: 'Bentonville',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: 'Greta has been DevAV\'s HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.',
Address: '1700 S Grandview Dr.',
State: 'Georgia',
City: 'Atlanta',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
State: 'Idaho',
City: 'Boise',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: 'Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you\'ve not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.',
Address: '4600 N Virginia Rd.',
State: 'Utah',
City: 'Beaver',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
State: 'California',
City: 'San Diego',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
State: 'Arkansas',
City: 'Little Rock',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
State: 'Missouri',
City: 'St. Louis',
}];
const tasks: Task[] = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
getTasks() {
return tasks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Reorder tabs
Wrap the TabPanel into the Sortable component and set the following properties as needed:
-
filter
Specify a CSS selector to indicate draggable items. This demo sets filter to.dx-tab. -
itemOrientation
Set this property to "horizontal". When a user drags a tab, remaining items move left and right to designate the drop target. -
onDragStart and onReorder
Implement these handlers to configure drag and drop logic and modify the dataSource after the tabs are reordered.
Add or remove tabs
This demo adds and removes tabs in the following two functions:
addButtonHandler- a click handler for the "Add Tab" button.closeButtonHandler- a click handler for a tab's Close icon. The demo uses the itemTitleTemplate property to display this icon.
Both handlers modify the TabPanel's dataSource.